"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _urlParse = _interopRequireDefault(require("url-parse"));

var Router =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(Router, _React$Component);

  function Router() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, Router);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(Router)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "state", {
      route: null
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "unlisten", null);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "clickHandler", function (event) {
      // $FlowFixMe
      var a = event.path.find(function (el) {
        return el.tagName === "A";
      });

      if (!a) {
        return;
      }

      if (a.href.endsWith("#") || a.target === "_blank") {
        return;
      } // Check if it's an anchor link


      if (a.href.indexOf("#") > -1) {
        return;
      }

      if (a.href.startsWith(window.location.origin)) {
        event.preventDefault();
        var router = _this.props.router;
        var history = router.history;
        var url = (0, _urlParse.default)(a.href, true);
        history.push(url.pathname, router.config.basename);
      }
    });
    return _this;
  }

  (0, _createClass2.default)(Router, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var router = this.props.router;
      var history = router.history;
      this.unlisten = history.listen(function () {
        router.matchRoute(history.location.pathname).then(function (route) {
          _this2.setState({
            route: route
          });
        });
      });
      document.addEventListener("click", this.clickHandler);
      router.matchRoute(history.location.pathname).then(function (route) {
        _this2.setState({
          route: route
        });
      });
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(props) {
      var _this3 = this;

      props.router.matchRoute(props.router.history.location.pathname).then(function (route) {
        if (typeof _this3.unlisten === "function") {
          _this3.setState({
            route: route
          });
        }
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.unlisten && this.unlisten();
      this.unlisten = null;
      document.removeEventListener("click", this.clickHandler);
    }
  }, {
    key: "render",
    value: function render() {
      return this.state.route;
    }
  }]);
  return Router;
}(_react.default.Component);

var _default = Router;
exports.default = _default;
//# sourceMappingURL=Router.cmp.js.map