"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _react = _interopRequireDefault(require("react"));

var _default = function _default() {
  return (
    /*#__PURE__*/
    function () {
      var _ref = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(params, next) {
        var route, match, resolve, component;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                route = params.route, match = params.match, resolve = params.resolve;

                if (route) {
                  _context.next = 3;
                  break;
                }

                return _context.abrupt("return", next());

              case 3:
                if (!route.render) {
                  _context.next = 7;
                  break;
                }

                _context.next = 6;
                return route.render({
                  route: route,
                  match: match,
                  resolve: resolve
                });

              case 6:
                params.output = _context.sent;

              case 7:
                if (!route.component) {
                  _context.next = 17;
                  break;
                }

                if (!(typeof route.component === "function")) {
                  _context.next = 14;
                  break;
                }

                _context.next = 11;
                return route.component();

              case 11:
                _context.t0 = _context.sent;
                _context.next = 15;
                break;

              case 14:
                _context.t0 = route.component;

              case 15:
                component = _context.t0;
                params.output = _react.default.createElement(component, {
                  route: route,
                  match: match,
                  resolve: resolve
                });

              case 17:
                if (typeof route.layout === "function") {
                  params.output = route.layout(params.output);
                }

                next();

              case 19:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x, _x2) {
        return _ref.apply(this, arguments);
      };
    }()
  );
};

exports.default = _default;
//# sourceMappingURL=render.js.map