"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _isObject2 = _interopRequireDefault(require("lodash/isObject"));

var _isArray2 = _interopRequireDefault(require("lodash/isArray"));

var _forOwn2 = _interopRequireDefault(require("lodash/forOwn"));

var traverse = function traverse(obj) {
  (0, _forOwn2.default)(obj, function (val, key) {
    if ((0, _isArray2.default)(val)) {
      val.forEach(function (el) {
        traverse(el);
      });
    } else if ((0, _isObject2.default)(val)) {
      traverse(val);
    } else {
      if (val === "true") {
        obj[key] = true;
      } else if (val === "false") {
        obj[key] = false;
      }
    }
  });
};

var _default = traverse;
exports.default = _default;
//# sourceMappingURL=parseBoolean.js.map